// 黒、青は、無接続
#define PHI1PIN		(7)	// 白
#define PHI2PIN		(6)	// 赤
#define PHI1BPIN	(5)	// 黄
#define PHI2BPIN	(4)	// 緑
#define VOLUMEPIN	(0)

#define BASESTEPANGLE	(1.0)	// 基本ステップ角度：1ステップで動く角度

void setup()
{
	pinMode(PHI1PIN, OUTPUT);
	pinMode(PHI2PIN, OUTPUT);
	pinMode(PHI1BPIN, OUTPUT);
	pinMode(PHI2BPIN, OUTPUT);
//	Serial.begin(9600);
}

void step_forward( int iRpm )
{
	// ・1ステップにかけるべき時間は、
	// 　(基本ステップ角度) * (rpmから求まる1度うごくのにかける時間）
	// ・rpmから求まる1度うごくのにかける時間は、
	//   　1 / ( iRpm[rpm] * 360[deg] / 60[s] ) = 1 / (iRpm * 6)
	// 　= 1 / (iRpm * 6)
	// ・1ステップ時間[s]は
	// 　StepTime = BASESTEPANGLE / (iRpm * 6)
	int iStepTime_milli = (int)(1000.0 * BASESTEPANGLE / (iRpm * 6));
//	Serial.println(iStepTime_milli);
	// P1:ON, P2:ON, P1B:off, P2B:off
	digitalWrite(PHI1PIN, HIGH);
	digitalWrite(PHI2PIN, HIGH);
	digitalWrite(PHI1BPIN, LOW);
	digitalWrite(PHI2BPIN, LOW);
	delay(iStepTime_milli);
	// P1:off, P2:ON, P1B:ON, P2B:off
	digitalWrite(PHI1PIN, LOW);
	digitalWrite(PHI1BPIN, HIGH);
	delay(iStepTime_milli);
	// P1:off, P2:off, P1B:ON, P2B:ON
	digitalWrite(PHI2PIN, LOW);
	digitalWrite(PHI2BPIN, HIGH);
	delay(iStepTime_milli);
	// P1:ON, P2:off, P1B:off, P2B:ON
	digitalWrite(PHI1BPIN, LOW);
	digitalWrite(PHI1PIN, HIGH);
	delay(iStepTime_milli);
}

void step_reverse( int iRpm )
{
	int iStepTime_milli = (int)(1000.0 * BASESTEPANGLE / (iRpm * 6));
//	Serial.println(iStepTime_milli);
	// P1:off, P2:off, P1B:ON, P2B:ON
	digitalWrite(PHI1PIN, LOW);
	digitalWrite(PHI2PIN, LOW);
	digitalWrite(PHI1BPIN, HIGH);
	digitalWrite(PHI2BPIN, HIGH);
	delay(iStepTime_milli);
	// P1:off, P2:ON, P1B:ON, P2B:off
	digitalWrite(PHI2BPIN, LOW);
	digitalWrite(PHI2PIN, HIGH);
	delay(iStepTime_milli);
	// P1:ON, P2:ON, P1B:off, P2B:off
	digitalWrite(PHI1BPIN, LOW);
	digitalWrite(PHI1PIN, HIGH);
	delay(iStepTime_milli);
	// P1:ON, P2:off, P1B:off, P2B:ON
	digitalWrite(PHI2PIN, LOW);
	digitalWrite(PHI2BPIN, HIGH);
	delay(iStepTime_milli);
}

void step_stop()
{
}


void loop()
{
	int iValue = analogRead(VOLUMEPIN);
//	Serial.println(iValue);
	iValue = iValue / 8;	// [0 1023] -> [0 127]
	if(      64 + 2 < iValue )
	{
		// iValue   :  64   127
		// rpm      :   1    64
		step_forward( iValue - 63 );
	}
	else if( 63 - 2 > iValue )
	{
		// iValue   :    0   63
		// rpm      :   64    1
		step_reverse( 64 - iValue );
	}
	else
	{
		step_stop();
	}
}

